from sqlite3 import IntegrityError

class PersistenceFacade(object):

	def __init__(self):
		#__mappers = {"Modelo":ModeloBDMapper,"Perfil":PerfilBDMapper}
		self.__modeloMapper = ModeloBDMapper()
		self.__perfilMapper = PerfilBDMapper()
		self.__entornoMapper = EntornoBDMapper()
		self.__mappers = {"Modelo": self.__modeloMapper, "Perfil": self.__perfilMapper,
					"Entorno": self.__entornoMapper}
		
	def putObject(self, obj):
		try:
			mp = self.__mappers[obj.__class__.__name__]
			mp.putObject(obj)
		except IntegrityError:
			raise

	def updateObject(self, obj):
		try:
			mp = self.__mappers[obj.__class__.__name__]
			mp.updateObject(obj)
		except IntegrityError:
			raise
			
	def getObject(self, clase, OID):
		mp = self.__mappers[clase]
		obj = mp.getObject(OID)
		return obj
	
	def getall(self, clase):
		mp = ModeloBDMapper()
		mp = self.__mappers[clase]
		objects = mp.getAll()
		return objects
		
from bd.modeloBDMapper import ModeloBDMapper
from bd.perfilBDMapper import PerfilBDMapper
from bd.entornoBDMapper import EntornoBDMapper
