# -*- coding: utf-8 -*-
import view.errormsg as errormsg
import model.utiles as utiles
from sqlite3 import IntegrityError
#Constantes
#arquitectura_values = ["i386", "amd64"]


class Entorno(object):

	def __init__(self):
		self.__nombre=""
		self.__ubicacionImg="" # No se utiliza.
		self.__perfiles=None
		self.__estado=""
		self.__nuevoNombre=None # Solo se utiliza cuando hay que cambiar el nombre.
		
	"""       G ETTERS      """
	def __getNombre(self):
		return self.__nombre

	def __getUbicacionImg(self):
		return self.__ubicacionImg

	def __getEstado(self):
		return self.__estado

	def __getNuevoNombre(self):
		return self.__nuevoNombre

	def __getPerfiles(self):
		return self.__perfiles

	"""       S ETTERS      """
	def __setNombre(self, nombre):
		self.__nombre = nombre

	def __setUbicacionImg(self, ubicacionImg):
		self.__ubicacionImg = ubicacionImg

	def __setEstado(self, estado):
		self.__estado = estado
		
	def __setNuevoNombre(self, nuevoNombre):
		self.__nuevoNombre = nuevoNombre		

	def __setPerfiles(self, perfiles):
		self.__perfiles = perfiles		

		
	nombre = property(fget=__getNombre, fset=__setNombre)
	ubicacionImg = property(fget=__getUbicacionImg, fset=__setUbicacionImg)
	estado = property(fget=__getEstado, fset=__setEstado)
	nuevoNombre = property(fget=__getNuevoNombre, fset=__setNuevoNombre)
	perfiles = property(fget=__getPerfiles, fset=__setPerfiles)
		
		
	@classmethod
	def getAll(cls):
		facade = PersistenceFacade()
		return facade.getall(cls.__name__)
		
		
	@classmethod
	def getObject(cls, OID):
		facade = PersistenceFacade()
		return facade.getObject(cls.__name__, OID)


	def putObject(self):
		try:
			facade = PersistenceFacade()
			facade.putObject(self)
		except IntegrityError:
			raise
	
	def updateObject(self):
		try:
			facade = PersistenceFacade()
			facade.updateObject(self)
		except IntegrityError:
			raise
			
	def deletePerfil(self, nombrePerfil):
		pm = EntornoBDMapper()
		pm.deletePerfil(self, nombrePerfil)
		
	def checkData(self):
		mssg = errormsg.intro_err + "\n\n"
		err = 0
		if not(self.nombre.isalnum()) or utiles.isEmpty(self.nombre):
			mssg += errormsg.nombre_err + '\n'
			err = 1
		if self.perfiles is None or not self.perfiles:
			mssg += errormsg.entSinPerfil_err + '\n'
			err = 1
		if self.nuevoNombre is not None:
			if not(self.nuevoNombre.isalnum()) or utiles.isEmpty(self.nuevoNombre):
				mssg += errormsg.nombre_err + '\n'
				err = 1
		return (err, mssg)
				
from bd.entornoBDMapper import EntornoBDMapper
from bd.persistenceFacade import PersistenceFacade

