# -*- coding: utf-8 -*-
import view.errormsg as errormsg
import model.utiles as utiles
from sqlite3 import IntegrityError
#Constantes
#arquitectura_values = ["i386", "amd64"]


class Perfil(object):

	def __init__(self):
		self.__nombre=""
		self.__ubicacionSnap="" # No se esta utilizando
		self.__modelo=""
		self.__estado=""
		self.__nuevoNombre=None # Solo se utiliza cuando hay que cambiar el nombre.
		
	"""       G ETTERS      """
	def __getNombre(self):
		return self.__nombre

	def __getUbicacionSnap(self):
		return self.__ubicacionSnap

	def __getEstado(self):
		return self.__estado

	def __getNuevoNombre(self):
		return self.__nuevoNombre

	def __getModelo(self):
		return self.__modeloNombre

	"""       S ETTERS      """
	def __setNombre(self, nombre):
		self.__nombre = nombre

	def __setUbicacionSnap(self, ubicacionSnap):
		self.__ubicacionSnap = ubicacionSnap

	def __setEstado(self, estado):
		self.__estado = estado
		
	def __setNuevoNombre(self, nuevoNombre):
		self.__nuevoNombre = nuevoNombre		

	def __setModelo(self, modeloNombre):
		self.__modeloNombre = modeloNombre		

		
	nombre = property(fget=__getNombre, fset=__setNombre)
	ubicacionSnap = property(fget=__getUbicacionSnap, fset=__setUbicacionSnap)
	estado = property(fget=__getEstado, fset=__setEstado)
	nuevoNombre = property(fget=__getNuevoNombre, fset=__setNuevoNombre)
	modelo = property(fget=__getModelo, fset=__setModelo)
		
	
	"""		Mapeo a BD		"""	
	@classmethod
	def getAll(cls):
		facade = PersistenceFacade()
		return facade.getall(cls.__name__)
		
		
	@classmethod
	def getObject(cls, OID):
		facade = PersistenceFacade()
		return facade.getObject(cls.__name__, OID)


	def putObject(self):
		try:
			facade = PersistenceFacade()
			facade.putObject(self)
		except IntegrityError:
			raise
	
	def updateObject(self):
		try:
			facade = PersistenceFacade()
			facade.updateObject(self)
		except IntegrityError:
			raise
	
	def putPaquete(self, paquete):
		# Utiliza el mapeador de perfiles para mapear el diccionario 'paquete'.
		pm = PerfilBDMapper()
		pm.putPaquete(paquete)
		
	def deletePaquete(self, idPaquete):
		#paquete es un diccionario con claves, las columnas de la tabla paquete.
		pm = PerfilBDMapper()
		pm.deletePaquete(idPaquete)
		
	def getAllPaquetes(self):
		pm = PerfilBDMapper()
		return pm.getAllPaquetes(self)
		
	"""		Comprobacion de consistencia en los datos		"""
	def checkData(self):
		mssg = "Preste atención a los siguientes datos:\n"
		err = 0
		if not(self.nombre.isalnum()) or utiles.isEmpty(self.nombre):
			mssg += errormsg.nombre_err + '\n'
			err = 1
		if self.nuevoNombre is not None:
			if not(self.nuevoNombre.isalnum()) or utiles.isEmpty(self.nuevoNombre):
				mssg += errormsg.nombre_err + '\n'
				err = 1
		return (err, mssg)
				
from bd.persistenceFacade import PersistenceFacade
from bd.perfilBDMapper import PerfilBDMapper
