import pygtk
pygtk.require("2.0")
import gtk

from model.modelo import Modelo
import model.utiles as utiles
from ctrl.gestorModelo import GestorModelo
import pprint
import view.utiles as utilesView
import model.utiles as utilesModel
import view.errormsg as errormsg



class PaginaModelo(object):

	# El builder del notebook
	__builder = None
	# Builder exclusivo de la pagina.
	__builderPagina = None
	__gestorModelo = None
	__dlgConfirmacionDesactivar = None

	def __init__(self, bld):
	
		self.__builder = bld
		self.__gestorModelo = GestorModelo(self)
		self.__connectSignals()
		self.__tvModelo = self.__builder.get_object("tvModelo")
		
		filename = utilesView.PAGINA_MODELO_GL
		self.__builderPagina = gtk.Builder()
		self.__builderPagina.add_from_file(filename)
		self.__builderPagina.connect_signals(self)

		self.__dlgConfirmacionDesactivar = self.__builderPagina.get_object("dlgConfirmacionDesactivar")
		self.__dlgConfirmacionGenImg = self.__builderPagina.get_object("dlgConfirmacionGenImg")
		
		# Establecer los mensajes de los dialogos
		self.__dlgConfirmacionDesactivar.set_markup(errormsg.desactivarModelo_msg)
		self.__dlgConfirmacionGenImg.set_markup(errormsg.genImgModelo_msg)
				
	def actualiza(self):

		listStore = self.__builder.get_object("lstoreModelo")
		
		listStore.clear()
		modelos = Modelo.getAll()
		for modelo in modelos:
			if(modelo.estado == utilesModel.estado_values[1]):
				listStore.append(['%s' % modelo.nombre])
		
		
	"""		Operaciones sobre la seleccion actual		"""	
	def on_butModConfig_clicked(self, widget):

		nombreModelo = utilesView.tv_getSelection(self.__tvModelo, 0)
		if not(nombreModelo is None):
			self.__gestorModelo.config(nombreModelo)


	"""		Desactivar el modelo seleccionado		"""
	def on_butTerminarDesactivar_clicked(self, widget):
		nombreModelo = utilesView.tv_getSelection(self.__tvModelo, 0)
		if not(nombreModelo is None):
			self.__gestorModelo.desactivar(nombreModelo)
			self.__dlgConfirmacionDesactivar.hide()
			
	def on_butVolverDesactivar_clicked(self, widget):
		self.__dlgConfirmacionDesactivar.hide()

	def on_butModDesactivar_clicked(self, widget):
		nombreModelo = utilesView.tv_getSelection(self.__tvModelo, 0)
		if not(nombreModelo is None):
			self.__dlgConfirmacionDesactivar.show()

	"""		Generar la imagen		"""
	def on_butTerminarGenImg_clicked(self, widget):
		nombreModelo = utilesView.tv_getSelection(self.__tvModelo, 0)
		if not(nombreModelo is None):
			self.__gestorModelo.generaImagen(nombreModelo)
			self.__dlgConfirmacionGenImg.hide()

	def on_butVolverGenImg_clicked(self, widget):
		self.__dlgConfirmacionGenImg.hide()

	def on_butModImg_clicked(self, widget):	
		nombreModelo = utilesView.tv_getSelection(self.__tvModelo, 0)
		if not(nombreModelo is None):
			self.__dlgConfirmacionGenImg.show()

		
	""" otras operaciones """
	def on_butModNuevo_clicked(self, widget):
		self.__gestorModelo.nuevo()
	
	def __connectSignals(self):
	
		self.__butModConfig = self.__builder.get_object("butModConfig")
		self.__butModConfig.connect("clicked", self.on_butModConfig_clicked)

		self.__butModImg = self.__builder.get_object("butModImg")
		self.__butModImg.connect("clicked", self.on_butModImg_clicked)

		self.__butModNuevo = self.__builder.get_object("butModNuevo")
		self.__butModNuevo.connect("clicked", self.on_butModNuevo_clicked)

		self.__butModDesactivar = self.__builder.get_object("butModDesactivar")
		self.__butModDesactivar.connect("clicked", self.on_butModDesactivar_clicked)	
		
