#! /usr/bin/env python
import gtk
# Ubicacion de los ficheros glade
INICIO_GL = "view/glade/prototipo1.glade"
PAGINA_ENTORNO_GL = "view/glade/paginaEntorno.glade"
PAGINA_MODELO_GL = "view/glade/paginaModelo.glade"
PAGINA_PERFIL_GL = "view/glade/paginaPerfil.glade"
CONFIG_ENTORNO_GL = "view/glade/configEntorno.glade"
CONFIG_PERFIL_GL = "view/glade/configPerfil.glade"
CONFIG_MODELO_GL = "view/glade/configModelo.glade"
NUEVO_ENTORNO_GL = "view/glade/nuevoEntorno.glade"
NUEVO_PERFIL_GL = "view/glade/nuevoPerfil.glade"
NUEVO_MODELO_GL = "view/glade/nuevoModelo.glade"

#

def inicializaCombobox(combo, lista, *seleccion):
	tStore = combo.get_model()
	tStore.clear()
	if not lista:
		lista.append("No hay elementos")
		
	for element in lista:
		tStore.append(['%s' % element])
		
	if seleccion:
		combo.set_active(lista.index(seleccion[0]))
	else:
		combo.set_active(0)
		
# Metodo para obtener la seleccion activa de un combobox.
def get_active_text(combobox):
      model = combobox.get_model()
      active = combobox.get_active()
      if active < 0:
          return None
      return model[active][0]

def tv_getSelection(tv, col):
	#Devuelve el nombre del modelo seleccionado
	sel_value = None
	sel = tv.get_selection()
	#tupla: (Model, Iter)
	tupla = sel.get_selected()	
	
	if tupla[1] is not None:
		sel_value = tupla[0].get_value(tupla[1], col)
		
	return sel_value
	
def tv_getSelection_iter(tv):
	#Devuelve el nombre del modelo seleccionado
	sel = tv.get_selection()
	#tupla: (ListStore, GtkTreeIter)
	tupla = sel.get_selected()	
	
	return tupla[1]

def lstore_getColList(lstore, col):
	# Devuelve una lista con los valores de la columna seleccionada
	# para cada fila presente.
	iter = lstore.get_iter_first()
	list = []
	while iter is not None:
		list.append(lstore.get_value(iter, col))
		iter = lstore.iter_next(iter)
	return list
	
def existe_toggled(lstore, col):
	# Devuelve una lista con los valores de la columna seleccionada
	# para cada fila presente.
	iter = lstore.get_iter_first()
	while iter is not None:
		if (lstore.get_value(iter, col)):
			return True
		iter = lstore.iter_next(iter)
	return False

