import pygtk
pygtk.require("2.0")
import gtk

import view.utiles as utilesView
from model.entorno import Entorno
from model.perfil import Perfil

class WinConfigEntorno(object):

	__gestorEntorno = None
	__builder = None
	
	# Componentes de la vista
	__tvPerfiles = None
	__lstorePerfiles = None
	__ntryNombre = None
	
	
	# Cuadros de dialogo.
	__dlgConfirmacion = None
	__dlgValidacion = None	
	__dlgNuevoEntorno = None
	
	__lastModeloToggled = None
	__entorno = None
	
	def __init__(self, ge, entorno):
		
		filename = utilesView.CONFIG_ENTORNO_GL
		self.__builder = gtk.Builder()
		self.__builder.add_from_file(filename)
		self.__builder.connect_signals(self)
		self.__gestorEntorno = ge
		self.__entorno = entorno
		

		self.__tvPerfiles = self.__builder.get_object("tvPerfiles")
		self.__lstorePerfiles = self.__builder.get_object("lstorePerfiles")
		self.__ntryNombre = self.__builder.get_object("ntryNombre")			
		self.__dlgConfirmacion = self.__builder.get_object("dlgConfirmacion")
		self.__dlgValidacion = self.__builder.get_object("dlgValidacionEntrada")
		self.__dlgNuevoEntorno = self.__builder.get_object("dlgConfigEntorno")

		# Inicializar la liststore de los perfiles
		self.__lstorePerfiles.clear()

		for perfil in Perfil.getAll():
			if perfil.nombre in entorno.perfiles:
				self.__lstorePerfiles.append([perfil.nombre, perfil.modelo, True])
				if self.__lastModeloToggled is None:
					self.__lastModeloToggled = perfil.modelo
			else:
				self.__lstorePerfiles.append([perfil.nombre, perfil.modelo, False])
				
		# Inicializar el nombre
		self.__ntryNombre.set_text(entorno.nombre)
					
		# Preparar la lista para mostrar en el combobox
		self.__dlgNuevoEntorno.show()

	
	""" Dialogo principal """
	def on_butGuardar_clicked(self, widget):
		self.__dlgConfirmacion.show()
		

	def on_butSalir_clicked(self, widget):
		self.terminar()
		
		
	""" Dialogo de confirmacion """
	def on_butTerminar_clicked(self, widget):
		winput = {}
		winput["nuevoNombre"] = self.__builder.get_object("ntryNombre").get_text()
		winput["nombre"] = self.__entorno.nombre
		winput["perfilesNuevos"] = []
		winput["perfilesEliminados"] = []
		 
		iter = self.__lstorePerfiles.get_iter_first()
		while iter is not None:
			if self.__lstorePerfiles.get_value(iter, 2) and (self.__lstorePerfiles.get_value(iter, 0) not in self.__entorno.perfiles):
					winput["perfilesNuevos"].append(self.__lstorePerfiles.get_value(iter, 0))
			elif  not self.__lstorePerfiles.get_value(iter, 2) and (self.__lstorePerfiles.get_value(iter, 0) in self.__entorno.perfiles):
				winput["perfilesEliminados"].append(self.__lstorePerfiles.get_value(iter, 0))
				
			iter = self.__lstorePerfiles.iter_next(iter)
				
		self.__dlgConfirmacion.hide()
		self.__gestorEntorno.actualizaEntorno(winput)
		
	def on_butVolver_clicked(self, widget):
		self.__dlgConfirmacion.hide()
		
	""" Dialogo de error de validacion """
	def errorValidacion(self, mssg):
		self.__dlgValidacion.set_markup(mssg)	
		self.__dlgValidacion.show()
	
	def on_butEntiendo_clicked(self, widget):
		self.__dlgValidacion.hide()
		
	""" Terminacion limpia """			
	def on_dlgNuevoEntorno_destroy(self, widget):
		self.terminar()

	def terminar(self):
		if not self.__dlgNuevoEntorno is None:
			self.__dlgNuevoEntorno.destroy()
		if not self.__dlgConfirmacion is None:
			self.__dlgConfirmacion.destroy()
		if not self.__dlgValidacion is None:
			self.__dlgValidacion.destroy()
		
	def on_tvToggleCell_toggled(self, widget, path):
		# Esta funcion cambia el valor booleano de la columna 'incluir perfil' cuando es cliqueado el checkbox.
		# No permite marcar perfiles que no pertenezcan al mismo modelo.
		
		iterSel = self.__lstorePerfiles.get_iter(path)
		
		#Valores de las columnas 1 y 2 de la seleccion actual.
		incluirSel = self.__lstorePerfiles.get_value(iterSel, 2)
		modeloSel = self.__lstorePerfiles.get_value(iterSel, 1)
		
		if not(utilesView.existe_toggled(self.__lstorePerfiles, 2)):
			self.__lstorePerfiles.set_value(iterSel, 2, not(incluirSel))		
			self.__lastModeloToggled = modeloSel				
		elif self.__lastModeloToggled == modeloSel:
			self.__lstorePerfiles.set_value(iterSel, 2, not(incluirSel))		
			

