import pygtk
pygtk.require("2.0")
import gtk

import view.utiles as utilesView
import model.modelo as consModelo
from model.modelo import Modelo

class WinConfigModelo(object):

	__gestorModelo = None
	__dlgConfirmacion = None
	__dlgValidacion = None
	__modelo = None
	
	def __init__(self, gm, model):
		filename = utilesView.CONFIG_MODELO_GL
		self.__builder = gtk.Builder()
		self.__builder.add_from_file(filename)
		self.__builder.connect_signals(self)
		self.__modelo = model
		self.__gestorModelo = gm
		
		self.__nombre = self.__builder.get_object("ntryNombre").set_text(self.__modelo.nombre)
		
		self.__cbxArq = self.__builder.get_object("cbxArquitectura")	
		utilesView.inicializaCombobox(self.__cbxArq, consModelo.arquitectura_values, self.__modelo.arquitectura)
		
		self.__cbxFini = self.__builder.get_object("cbxFinicial")	
		utilesView.inicializaCombobox(self.__cbxFini, consModelo.fInicial_values, self.__modelo.instalacion)
		
		self.__cbxEscrit = self.__builder.get_object("cbxEscritorio")	
		utilesView.inicializaCombobox(self.__cbxEscrit, consModelo.escritorio_values,self.__modelo.entornoGrafico)
		
		self.__username = self.__builder.get_object("ntryUsername").set_text(self.__modelo.username)
		self.__hostname = self.__builder.get_object("ntryHostname").set_text(self.__modelo.hostname)
		
		self.__win = self.__builder.get_object("dlgConfigModelo")
		self.__win.show()

		
	""" Dialogo principal """
	def on_butGuardar_clicked(self, widget):
		self.__dlgConfirmacion = self.__builder.get_object("dlgConfirmacion")	
		self.__dlgConfirmacion.show()
		

	def on_butSalir_clicked(self, widget):
		self.terminar()
		
		
	""" Dialogo de confirmacion """
	def on_butTerminar_clicked(self, widget):
		winput = {}
		winput["nuevoNombre"] = self.__builder.get_object("ntryNombre").get_text()
		winput["nombre"] = self.__modelo.nombre
		winput["arquitectura"] = utilesView.get_active_text(self.__cbxArq)
		winput["fInicial"] = utilesView.get_active_text(self.__cbxFini)
		winput["escritorio"] = utilesView.get_active_text(self.__cbxEscrit)
		winput["username"] = self.__builder.get_object("ntryUsername").get_text()
		winput["hostname"] = self.__builder.get_object("ntryHostname").get_text()

		self.__dlgConfirmacion.hide()
		self.__gestorModelo.actualizaModelo(winput)
		
	def on_butVolver_clicked(self, widget):
		self.__dlgConfirmacion.hide()
		
	""" Dialogo de error de validacion """
	def errorValidacion(self, mssg):
		self.__dlgValidacion = self.__builder.get_object("dlgValidacionEntrada")
		self.__dlgValidacion.set_markup(mssg)	
		self.__dlgValidacion.show()
	
	def on_butEntiendo_clicked(self, widget):
		self.__dlgValidacion.hide()
		
	""" Terminacion limpia """			
	def on_dlgNuevoModelo_destroy(self, widget):
		self.terminar()

	def terminar(self):
		if not self.__win is None:
			self.__win.destroy()
		if not self.__dlgConfirmacion is None:
			self.__dlgConfirmacion.destroy()
		if not self.__dlgValidacion is None:
			self.__dlgValidacion.destroy()




