import pygtk
pygtk.require("2.0")
import gtk

import view.utiles as utilesView
import model.modelo as consModelo

class WinNuevoModelo(object):

	__gestorModelo = None
	__dlgConfirmacion = None
	__dlgValidacion = None
	__builder = None
	
	def __init__(self, gm):
		filename = utilesView.NUEVO_MODELO_GL
		self.__builder = gtk.Builder()
		self.__builder.add_from_file(filename)
		self.__builder.connect_signals(self)
		
		self.__gestorModelo = gm
		

		self.__cbxArq = self.__builder.get_object("cbxArquitectura")	
		utilesView.inicializaCombobox(self.__cbxArq, consModelo.arquitectura_values)
		
		self.__cbxFini = self.__builder.get_object("cbxFinicial")	
		utilesView.inicializaCombobox(self.__cbxFini, consModelo.fInicial_values)
		
		self.__cbxEscrit = self.__builder.get_object("cbxEscritorio")	
		utilesView.inicializaCombobox(self.__cbxEscrit, consModelo.escritorio_values)

		self.__win = self.__builder.get_object("dlgNuevoModelo")
		self.__win.show()

	""" Dialogo principal """
	def on_butGuardar_clicked(self, widget):
		self.__dlgConfirmacion = self.__builder.get_object("dlgConfirmacion")	
		self.__dlgConfirmacion.show()
		

	def on_butSalir_clicked(self, widget):
		self.terminar()
		
		
	""" Dialogo de confirmacion """
	def on_butTerminar_clicked(self, widget):
		winput = {}
		winput["nombre"] = self.__builder.get_object("ntryNombre").get_text()
		winput["arquitectura"] = utilesView.get_active_text(self.__cbxArq)
		winput["fInicial"] = utilesView.get_active_text(self.__cbxFini)
		winput["escritorio"] = utilesView.get_active_text(self.__cbxEscrit)
		winput["username"] = self.__builder.get_object("ntryUsername").get_text()
		winput["hostname"] = self.__builder.get_object("ntryHostname").get_text()

		self.__dlgConfirmacion.hide()
		self.__gestorModelo.almacenaModelo(winput)
		
	def on_butVolver_clicked(self, widget):
		self.__dlgConfirmacion.hide()
		
	""" Dialogo de error de validacion """
	def errorValidacion(self, mssg):
		self.__dlgValidacion = self.__builder.get_object("dlgValidacionEntrada")
		self.__dlgValidacion.set_markup(mssg)	
		self.__dlgValidacion.show()
		print "vista valida"
	
	def on_butEntiendo_clicked(self, widget):
		self.__dlgValidacion.hide()
		
	""" Terminacion limpia """			
	def on_dlgNuevoModelo_destroy(self, widget):
		self.terminar()

	def terminar(self):
		if not self.__win is None:
			self.__win.destroy()
		if not self.__dlgConfirmacion is None:
			self.__dlgConfirmacion.destroy()
		if not self.__dlgValidacion is None:
			self.__dlgValidacion.destroy()


		
