import pygtk
pygtk.require("2.0")
import gtk

import view.utiles as utilesView
from model.perfil import Perfil
from model.modelo import Modelo
import view.errormsg as errormsg

class WinNuevoPerfil(object):

	__gestorPerfil = None
	__builder = None
	
	#Componentes de la vista
	__cbxModelos = None
	__tvPaquetes = None
	__ntryNombre = None
	__ntryPaquete = None
	__listaPaquetes = None

	# Cuadros de dialogo
	__dlgConfirmacion = None
	__dlgValidacion = None	
	__dlgNuevoPerfil = None
	
	def __init__(self, gp):
		
		filename = utilesView.NUEVO_PERFIL_GL
		self.__builder = gtk.Builder()
		self.__builder.add_from_file(filename)
		self.__builder.connect_signals(self)
		self.__gestorPerfil = gp
		
		self.__cbxModelos = self.__builder.get_object("cbxModelos")
		self.__tvPaquetes = self.__builder.get_object("tvPaquetes")
		self.__ntryNombre = self.__builder.get_object("ntryNombre")
		self.__ntryPaquete = self.__builder.get_object("ntryPaquete")
		self.__listaPaquetes = self.__builder.get_object("lstore_listaPaquetes")
		self.__listaPaquetes.clear()
		
		self.__dlgConfirmacion = self.__builder.get_object("dlgConfirmacion")
		self.__dlgValidacion = self.__builder.get_object("dlgValidacionEntrada")
		
		# Preparar la lista para mostrar en el combobox
		l=[]
		for modelo in Modelo.getAll():
			l.append(modelo.nombre)
			
		utilesView.inicializaCombobox(self.__cbxModelos, l)
		
		self.__dlgNuevoPerfil = self.__builder.get_object("dlgNuevoPerfil")
		self.__dlgNuevoPerfil.show()


	""" Manejadores para la lista de paquetes """
	def on_butAdPaquete_clicked(self, widget):
		paquete = self.__ntryPaquete.get_text()
		if not(paquete == "" or paquete.isspace()):
			self.__listaPaquetes.append(['%s' % paquete])
			self.__ntryPaquete.set_text("")
		else:
			self.__dlgValidacion.set_markup(errormsg.paquete_err)	
			self.__dlgValidacion.show()
			self.__ntryPaquete.set_text("")
		
	def on_butRmPaquete_clicked(self, widget):
		seleccionIter = utilesView.tv_getSelection_iter(self.__tvPaquetes)
		if seleccionIter is not None:
			self.__listaPaquetes.remove(seleccionIter)
	
	""" Dialogo principal """
	def on_butGuardar_clicked(self, widget):
		self.__dlgConfirmacion.show()
		

	def on_butSalir_clicked(self, widget):
		self.terminar()
		
		
	""" Dialogo de confirmacion """
	def on_butTerminar_clicked(self, widget):
		winput = {}
		winput["nombre"] = self.__builder.get_object("ntryNombre").get_text()
		winput["modelo"] = utilesView.get_active_text(self.__cbxModelos)
		winput["paquetes"] = utilesView.lstore_getColList(self.__listaPaquetes, 0)		

		self.__dlgConfirmacion.hide()
		self.__gestorPerfil.almacenaPerfil(winput)
		
	def on_butVolver_clicked(self, widget):
		self.__dlgConfirmacion.hide()
		
	""" Dialogo de error de validacion """
	def errorValidacion(self, mssg):
		self.__dlgValidacion.set_markup(mssg)	
		self.__dlgValidacion.show()
	
	def on_butEntiendo_clicked(self, widget):
		self.__dlgValidacion.hide()
		
	""" Terminacion limpia """			
	def on_dlgNuevoPerfil_destroy(self, widget):
		self.terminar()

	def terminar(self):
		if not self.__dlgNuevoPerfil is None:
			self.__dlgNuevoPerfil.destroy()
		if not self.__dlgConfirmacion is None:
			self.__dlgConfirmacion.destroy()
		if not self.__dlgValidacion is None:
			self.__dlgValidacion.destroy()

